/*
   physical field table
*/
#ifndef _FIELD_H
#define _FIELD_H

#define	MINCHAR  0		/* ???? a jls (cr/f)eature */
#define MAXCHAR	 127

extern int COLS;
#define MAXCOL COLS

struct fldtbl {
  char row,col,len;	/* current screen location */
  char min,lcnt;	/* top line, number of lines */
  short nul;		/* null (field) character used plus attribute */
};
struct window;

typedef struct fwindow {
  short fld;		/* current field */
  short line;		/* current line */
  short key;		/* last function key */
  short nflds;		/* number of physical fields */
  struct fldtbl *tbl;	/* current physical field table */
  struct window *w;	/* current curses window */
  const char *name;	/* name of window/image file */
  short lfld;		/* current logical field */
} FWINDOW;

#define get_fld(f)	(fwin->tbl + f)
#define get_fsline(f)	(get_fld(f)->row - get_fld(f)->min)

extern FWINDOW *fwin;		/* current window context */
extern void fsinit( void );	/* startup */
extern void fsend( void );	/* shutdown */
extern void fsmark( int );	/* highlight field w/ current attr */
extern int poscurs( int );	/* edit a field, return fskey */
extern int poscursmod(int,char *);
extern int dispscrn( const char *,int );	/* display image file */
extern int getfield( int,char *,int );		/* get field data */
extern int putfield( int,const char *,int );	/* put field data */
extern int liner( int );		/* set current line pointer */
extern void display( void );
extern FWINDOW *fwinopen( const char *, int, int, int, int );
extern FWINDOW *fwindisp( FWINDOW * );
extern void fwinrest( FWINDOW * );
extern int mvwin(struct window *,int,int);
extern int overwrite(struct window *,struct window *);
extern void domark(int,int,int,char *);

#define flds	fwin->tbl
#define fsnflds	fwin->nflds
#define fslfld	fwin->lfld
#define fsfld	fwin->fld
#define fsline	fwin->line
#define pfskey	fwin->key

#endif
