/*  This module contains the necessary structures for full screen functions  */

#include <field.h>
#ifndef _FS_H		/* look to see if this file already processed */
#define _FS_H		/* added 1/24/85 jls for ifndef in keydef.h */
#define	MINCHAR  0
#define MAXCHAR	 127

typedef struct field {
  short fld;		/* screen location */
  int (*get)(),(*put)();	/* data type processing functions */
  char *dat;		/* pointer to data */
  short len;		/* length of data */
  char *opt;		/* application dependent info */
  char *inq;		/* inquiry program name */
  short up,dn;		/* field to go to for up or down arrow */
} FIELD; 

typedef struct {
  short size;
  FIELD *tbl;
  short sfld,slin;
} TBLPTR;

#define fldgen(f,g,p,d,o,i) {f,g,p,(char *)&(d),sizeof(d),o,i,-1,-1}
#define strgen(f,g,p,d,o,i) {f,g,p,(char *)(d),sizeof(d),o,i,-1,-1}
#define fldgenf(f,g,p,d,o,i,up,dn) {f,g,p,(char *)&(d),sizeof(d),o,i,up,dn}
#define strgenf(f,g,p,d,o,i,up,dn) {f,g,p,(char *)(d),sizeof(d),o,i,up,dn}

extern void putscrn(int,FIELD *), upper(), lower(), fserr();
extern int getscrnmod(int,FIELD *,int,int,char *,int);
#define getscrn(a,b,c,d) getscrnmod(a,b,c,d,(char *)0,0)
#ifndef count
#define count(a) (sizeof a/sizeof a[0])
#endif

#define putstrn 	putstr		/* to solve inconsistent use */
#define getstr		getstrn		/* to solve inconsistent use */
extern int getstrn(),putstr(),getnull(),putnull(),putstat();
extern int getcust(),putcust();
extern int getpic(),getpicl(),getltr(),getacct(),putacct(),getlong();
extern int putlong(),putsub(),getsub();
#define getdate fsgetdate
extern int getdate(int,char *,char *,int);
extern int getdatef(int,char *,char *,int);
extern int putdatef(int,char *,char *,int);
extern int putdate(int,char *,char *,int);
extern int putpic(),putpicl(),putltr(),putstring();
extern int putpicf(),getpicf();
extern int putpiclf(),getpiclf(),getyn(),putyn();
extern int getshort(),putshort(),getvnd(),putvnd(),getpicif();
extern int getshortf(),putshortf();
extern int gettm(),puttm(),gettimef(),puttimef();
extern int puttime(),putpriv(),putvect(),putpici(),putpicif();
extern int getvect(),getpriv(),getpici(),gettbl(),puttbl();
extern int getgldate(),gettme(),puttme(),putglsub(),getcode(),putcode();
extern int getltrl(),putltrl(),getgldept(),putgldept(),getglsub();
extern int getstrl(),putstrl(),getartran(),getjrl(),putjrl(),gettran();
extern int getnum(),putnum(),getnumf(),putnumf();
extern int gethex(),puthex();
extern int getflags(),putflags();
extern short fstime;
extern void setupdn();
extern void dropscrn(void);
extern void restscrn(void);
extern int getdata(const char * , int , FIELD *),
	   putdata(const char *, int , FIELD *);
#endif
