/*
  structure info macros
  spos	- member offset
  sposa	- array member offset
  slen	- member size
  smp	- convert "pointer to member" to "pointer to enclosing structure"
  smpa	- smp for array member
*/
#define spos(s,m)	((char *)&((struct s *)0)->m - (char *)0)
#define sposa(s,m)	((char *)((struct s *)0)->m - (char *)0)
#define slen(s,m)	(sizeof((struct s *)0)->m)
#define smp(s,m,p)	((struct s *)((char *)(p)-spos(s,m)))
#define smpa(s,m,p)	((struct s *)((char *)(p)-sposa(s,m)))

/* macros useful when initializing offset,length pairs such as those
   in a key description. (Originally defined in bms.h)
*/
#define	kpos(s,m)	sposa(s,m),slen(s,m)
#define	kposchar(s,m)	spos(s,m),slen(s,m)
#define	kcharpos(s,m)	kposchar(s,m)

#ifndef count
#define count(a) (sizeof a/sizeof a[0])
#endif
